% handle_value_script shows the different bahaviours of handle classes and
% value classes.

%% generate handle and value objects with identical property values
disp('generate handle and value objects with identical property values')
ho1=handle_obj(27)

vo1=value_obj(27)

pause

%% even though the content is equal, the objects are not
disp('even though the content is equal, the objects are not')
equaltest=isequal(ho1,vo1)

pause

%% generate copies of the objects
disp('generate copies of the objects')
ho2=ho1
vo2=vo1

pause

%% Test for equality of copies
disp('Test for equality of copies')
equaltest_ho=isequal(ho1,ho2)
equaltest_vo=isequal(vo1,vo2)

pause
%% the property values can be changed in the same way
disp('the property values can be changed in the same way')
ho1.prop1='red'
vo1.prop1='red'

pause

%% However, the behavior of the copies is different!
disp('However, the behavior of the copies is different!')
ho2
vo2

pause
%% call a function without output arguments
disp('call a function without output arguments with a handle object')
ho1
changevalue(ho1);
ho1

pause

disp('call a function without output arguments with a value object')
vo1
changevalue(vo1);
vo1

pause

%% call a function with output arguments, using a new variable
disp('call a function with output arguments for a handle object, using a new variable')
ho1
ho3=changevalue2(ho1)
ho1

pause

disp('call a function with output arguments for a value object, using a new variable')
vo1
vo3=changevalue2(vo1)
vo1

%% call a function with output arguments, overwriting the object
disp('call a function with output arguments for a handle object, overwriting the object')

disp('before function call')
ho1.prop3=27  %change property to make effect visible
ho2
disp('after')
ho1=changevalue2(ho1)
ho2

pause

disp('call a function with output arguments for a value object, overwriting the object')
disp('before function call')
vo1.prop3=27  %change property to make effect visible
vo2
disp('after')
vo1=changevalue2(vo1)
vo2
